----------------------------------------------------------
----------- Comment system by Joni And Friends------------
----------------------------------------------------------
----------------------------------------------------------

function initArray(m)
      local array = {}
         for i = 1, m do
           array[i]=0
         end
      return array
end

function totable(t,match)
	local cmd = {}
	if not match then match = "[^%s]+" end
	for word in string.gmatch(t, match) do
		table.insert(cmd, word)
	end 
	return cmd 
end
----------------------------------------------------------

---=== Settings ===---
jaf_max_cmt=20 --- maximum comment to saving
jaf_cmtdir="sys/lua/JAF/comment.txt" --- location file comment data


---=== Table's ===----
jaf_cmt_get={} --- table for get comment from comment data
cmd={
         {cmd="!comment",     --- type comment
          action=function(id,txt,b,c)
                 if jaf_checkcmt()<jaf_max_cmt then
                 jaf_save_cmt(id,txt:sub(#cmd[1].cmd+1,#txt))
                     msg2(id,"[Server] \169000555000SYSTEM: Succefuly give comment to server(CMTempty:"..jaf_max_cmt-jaf_checkcmt().."(E))")
                 elseif jaf_checkcmt()>=jaf_max_cmt then
                      msg2(id,"[Server] \169255000000ERROR: Our comment system already in maximum of comment(CMTcount:"..jaf_checkcmt().."(F))")
                 end
          end
          };
         {cmd="!clear_comment",     --- type comment
          action=function(id,txt,b,c)
             jaf_remove_cmt() --- removing comment data
             msg2(id,"[Server] \169000555000Comment has been removed")
          end
          };
}


---=== Hooks ===---
addhook("menu","jaf_cmt_menu")
addhook("serveraction","jaf_cmt_serveraction")
addhook("say","jaf_cmt_say")


---=== Functions ===---
function jaf_save_cmt(id,msgs) --- parameters [id: player ID & msgs: player comment]
        filename=jaf_cmtdir     --- file location of the comment data
	local file = io.open(filename,"a")       --- opening the comment data
        if file then        --- checking file exists
	local text = ""      --- local variable of text
	textt = player(id,"name").."["..player(id,"usgn").."]:"..msgs     --- variable of textt
	text = text..""..textt       --- adding comment
        text = text.."\r\n"       --- creating new line
	file:write(text)        --- writing the comment into comment file data
	file:close()           --- closing  the comment file data & save it
        end
end

function jaf_checkcmt()          --- nil parameter
	local filename=jaf_cmtdir
	local file=io.open(filename)
        b=0       --- adding variable b for count
	if file then
		for line in file:lines() do       --- loop lines exists
				if line~=nil then      --- checking line exists
                                     b=b+1           --- count the line exists
                                     jaf_cmt_get[b]=line       --- get the comment from line exists
				end
		end
		if file ~= nil then
			file:close()
		end
	end		
	return b   --- return to b result(this showing the comment amount)
end

function jaf_remove_cmt()
     jaf_checkcmt()      --- checking and get comment from comment data
     for i=1,jaf_checkcmt() do
          if jaf_cmt_get[i] then
            jaf_cmt_get[i]=nil
          end
     end
        filename=jaf_cmtdir
	local file = io.open(filename)
        if file then
        os.remove(filename)        --- removing comment data
        io.output(io.open(filename,"w+"))     --- creating comment data
        else
        io.output(io.open(filename,"w+"))      --- creating comment data
        end
end

function jaf_cmtPmenu(id,page) --- parameters [id: player ID & page: menu page]
jaf_checkcmt()       --- checking and get comment from comment data
local page=page or 1       --- local page amount
local pages=math.ceil(jaf_checkcmt() /7)       --- calculate max page
         if page<1 then
              page=pages
         end
          local m='Comment check | Page '..page       --- title menu
          for i=7*page-6, 7*page do       --- loop
               if jaf_cmt_get[i] then        --- check comment exists
                    r=""        --- variable r
                    if #jaf_cmt_get[i]>24 then        --- check comment character amount
                    r=" "..jaf_cmt_get[i]:sub(1,24).."..."
                    else
                    r=" "..jaf_cmt_get[i]..""
                    end
                    m=m..','..r
                else
                    m=m..','
               end
           end
                  m = m ..',Next|Page '..(page+1)..'' 
           if page == 1 then 
                  m = m ..',Last page|Page '..pages..'' 
           else 
                  m = m ..',Previous|Page '..(page-1)..'' 
           end
     menu(id, m)
end

function jaf_cmt_menu(id,title,button)    --- parameters
if title:sub(1,21)=="Comment check | Page " then       --- check comment title menu
        local page=tonumber(title:sub(22))        --- check page amount
          if button==8 then
        jaf_cmtPmenu(id,page+1)
    end
          if button==9 then
        jaf_cmtPmenu(id,page-1)
    end
          if button==0 then
        return 1
    end
           if button<=7 then
            a=((page-1)*7+ button)      --- count button in page
            if jaf_cmt_get[a] then      --- check comment exists
            msg2(id,"[CMT]\169000555000"..jaf_cmt_get[a])          --- showed comment from comment data
            else
            msg2(id,"[Server] \169255000000This comment has been removed by server")
            end
        end
end
end

function jaf_cmt_serveraction(id,action)       --- parameters
          if action==1 then
             jaf_cmtPmenu(id,1)      --- open comment menu page 1
          end
end


function jaf_cmt_say(id,txt) --- parameters [id: player ID & txt: player massage]
   t=string.lower(txt)
   _msg=totable(txt)
   _t1=tostring(_msg[1]) ----- string 1 on txt
   _t2=tostring(_msg[2]) or tonumber(_msg[2]) ----- string 2 on txt
   _t3=tostring(_msg[3]) or tonumber(_msg[3]) ----- string 3 on txt
         for g=1,#cmd do ------ this for find the value of the cmd
          if _t1:sub(1,1)=="!" and _t1==cmd[g].cmd then ---- filtering 
          cmd[g].action(id,txt,_t2,_t3) ------- call the var the action of cmd
        return 1 ------ 1 for hide msg and 0 for show msg
     end
  end
          if _t1:sub(1,1)=="!" then --------- if command not right
          msg2(id,"\169255000000Command ".._t1.." are not found!")
       return 1
  end
end